//
// DataViewController.m
// UiSpike
//
// Created by So Koide on 2012/07/28.
// Copyright (c) 2012 sokoide.com. All rights reserved.
//

#import "DataViewController.h"

@interface DataViewController ()
- (void)updateInformation:(NSTimer *)timer;
@end

@implementation DataViewController

const NSString *kProgressViewKey = @"pgkey";
const NSString *kAlertViewKey    = @"alkey";
static float    progressValue    = 0.0f;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    self.dataLabel = nil;
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.dataLabel.text = [self.dataObject description];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown;
    } else {
        return YES;
    }
}

#pragma mark - IBAction
- (IBAction)OnAlert:(id)sender {
    NSLog(@"hoge");

    UIAlertView    *alertView    = [[UIAlertView alloc] initWithTitle:@"Download" message:@"Downloading Windows8..." delegate:self cancelButtonTitle:@"cancel" otherButtonTitles:nil];
    UIProgressView *progressView = [[UIProgressView alloc] initWithFrame:CGRectMake(30.0f, 80.0f, 225.0f, 90.0f)];

    [alertView addSubview:progressView];
    [progressView setProgressViewStyle:UIProgressViewStyleBar];

    [alertView show];

    progressValue = 0.0f;
    NSDictionary *userInfo = [NSDictionary dictionaryWithObjectsAndKeys:
                              progressView, kProgressViewKey, alertView, kAlertViewKey, nil];
    timer = [NSTimer scheduledTimerWithTimeInterval:0.1f target:self selector:@selector(updateInformation:) userInfo:userInfo repeats:YES];
}

#pragma mark - UIAlertView
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    NSLog(@"%d tapped", buttonIndex);
    [timer invalidate];
}

- (void)willPresentAlertView:(UIAlertView *)alertView {
    // change alertview position & size
    CGRect frame = alertView.frame;

    frame.origin.y    -= 15;
    frame.size.height += 30;
    alertView.frame    = frame;

    // change button position
    for (UIView *view in alertView.subviews) {
        frame = view.frame;

        if (frame.origin.y > 80) {
            frame.origin.y += 25;
            view.frame      = frame;
        }
    }
}

#pragma mark - private methods
- (void)updateInformation:(NSTimer *)aTimer {
    NSDictionary   *userInfo     = [aTimer userInfo];
    UIProgressView *progressView = [userInfo objectForKey:kProgressViewKey];

    if (progressValue >= 1.0f) {
        // stop timer
        [timer invalidate];

        // dismiss alertview
        UIAlertView *alertView = [userInfo objectForKey:kAlertViewKey];
        [alertView dismissWithClickedButtonIndex:alertView.cancelButtonIndex
                                        animated:YES];
        return;
    }

    // update progressview
    progressValue        += 0.01f;
    progressView.progress = progressValue;
    NSLog(@"value=%f", progressValue);
}

@end
